#include <bits/stdc++.h>
using namespace std;
    string a, b[100001];
    long long n, m, p, l;
int main (){
ios_base::sync_with_stdio(false);
cin.tie(0);
cout.tie(0);
    long long i, j;
    cin >> a;
    n=a.length();
    cin >> m;
    for (i=0; i<m; i++){
        cin >> b[i];
    }
    int l1=0, l2=n;
    while (l!=a.length()){
        l1=a.length();
        int len;
        for (i=0; i<m; i++){
            p=a.substr(0,l1).find(b[i]);
            if (p!=string::npos){
                l1=p;
                len=b[i].size();
            }
            if (l1<l2){break;}
        }
        l2=l1;
        a.erase(l1, len);
    }
        cout << a << endl;

return 0;
}
